//+------------------------------------------------------------------+ 
//|   TRO_C4                                                         | 
//|                                                                  | 
//|   Copyright  2009, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|   All my indicators should be considered donationware. That is   |
//|   you are free to use them for your personal use, and are        |
//|   under no obligation to pay for them. However, if you do find   |
//|   this or any of my other indicators help you with your trading  |
//|   then any Gift or Donation as a show of appreciation is         |
//|   gratefully accepted.                                           |
//|                                                                  |
//|   Gifts or Donations also keep me motivated in producing more    |
//|   great free indicators. :-)                                     |
//|                                                                  |
//|   PayPal - THERUMPLEDONE@GMAIL.COM                               |  
//+------------------------------------------------------------------+  
 

//----
#property indicator_chart_window

extern bool   Sound.Alert    = true ;
extern string Sound.File     = "startgun.wav" ; // TRO

extern int myChartX   = 10 ;
extern int myChartY   = 600 ;
 int myCorner   = 1 ;
extern string myFont  = "Courier New" ;
extern int myFontSize = 12 ;

string Symbols ;


extern int       myPeriod       = 5 ;

extern int  TRIX_Period = 2;
 
extern int Mode_Average_1 = 1;
extern int Mode_Average_2 = 1;
extern int Mode_Average_3 = 1;
 
extern int Input_Price = 0;
extern int iArrow = 167;
extern int  CountBars = 500;
extern bool Draw_Closes = true;
 
 
extern int       MAPeriod=10;
extern int       MAType=3;
extern int       MAAppliedPrice = 6;//0=close, 1=open, 2=high, 3=low, 4=median(high+low)/2, 5=typical(high+low+close)/3, 6=weighted(high+low+close+close)/4
 
 
extern color colorHD =    Orange ;

extern color  colorBUY   = Lime;
extern color  colorSELL  = Red ; 
extern color  colorSHORT = Crimson;
extern color  colorCOVER = Green ; 
extern color  colorWAIT  = DimGray ;


string symbol, tChartPeriod, ShortName ;  

int     digits, period, win, digits2, n, j, i, w; 
 

double point, point2, value ;
string lbl[15], lbl2[15], pArrow, D1Arrow, W1Arrow, MNArrow;
color pColor = Blue ;


//---- PipsToOpen
string Indicator_Name = "C4:" ;
int Objs = 0;

//+------------------------------------------------------------------+ 
int     ind_bufferOp[] ;
string shortName ;
int    cpairsLenH;
int    cpairsLenV;
int    shortLength;
int    ctimesLen;
string cpairsh[];
string cpairsv[];
int    aTimes[];
string addition  = "";
string FontToUse = "Terminal";
 

string  sDailyOpen , tMessage, tAlert ;  
int      LastAOFS ;
double   DailyOpen ;


string ArrowReverse   ; 
string ArrowDemand  ;  
string ArrowSupply   ;  
string ArrowWarning   ;  
string ArrowNoSignal   ;  

string theArrow, theArrowDet, theArrowCharge;
color   theColor, theColorDet, theColorCharge, theColorTR;
 

string ArrowHeadRt =  "" ; // 216 up arrow head
string ArrowHeadUp =  "" ; // 217 up arrow head
string ArrowHeadDn =  "" ; // 218 up arrow head 

double    C, O, H, L  , C1, O1, H1, L1, C2 ;
 

int UseFontSize = 12,  HH, HL, LH, LL, yy,mm,dd  ; 

int x001, x002, x003, x004, x005, x006, x007, x008, x009 ; 

string ArrowDot, ArrowBomb ;
double TheBuffer, TheBufferDet, TheBufferCharge, TheBufferTrixM15 ;

datetime Trigger ;

bool plunger = true ;

//+------------------------------------------------------------------+
int init()
{
  
   ArrowDot    = CharToStr(108) ; 
   ArrowBomb   = CharToStr(77) ; 
    
   Symbols = Symbol() ; 

   if(myPeriod == 0) { period = Period() ; } else { period = myPeriod ; }  
 
   tChartPeriod =  TimeFrameToString(period) ;
   symbol       =  Symbol() ;
   digits       =  Digits ;
   point        =  Point ;
   shortName    =  "C4" ;
   win          =  0 ;

   if(digits == 5 || digits == 3) { digits2 = 0 ; point = point * 10 ; } else { digits2 = 0 ; }

   setUpStrings(cpairsh,cpairsLenH,Symbols);

   if (IsMini())   addition="m";
   if (IsDoubleDotted()) addition="..";
   else 
      if (IsDotted()) addition=".";
   
      shortLength = StringLen(shortName);
      IndicatorShortName(shortName);

   ShortName = shortName ;

if( myCorner == 0 || myCorner == 2 )
{ 
   x001 = 0 ;
   x002 = 0 ;     // pair
   x003 = 70 ;    // d1 arrow
   x004 = 110;    // message
   x005 = 80 ;   // w1 arrow
   x006 = 90;    // mn arrow 
   x007 = 90 ;     
}
else
{
   x001 = 0 ;
   x002 = 130 ;   // pair
   x003 = 90 ;    //   arrow
   x004 = 50 ;    // arrow
   x005 = 10 ;   //      
   x006 = 0 ;   //     
   x007 = 00 ; 
   x008 = 000 ;   //    
   x009 = 0 ;    //  
     
}

   deinit() ;  

   return(0);
  }

//+------------------------------------------------------------------+

void ObDeleteObjectsByPrefix(string Prefix)
  {
   int L = StringLen(Prefix);
   int i = 0; 
   while(i < ObjectsTotal())
     {
       string ObjName = ObjectName(i);
       if(StringSubstr(ObjName, 0, L) != Prefix) 
         { 
           i++; 
           continue;
         }
       ObjectDelete(ObjName);
     }
  } 
//+------------------------------------------------------------------+
int deinit()
{
 ObDeleteObjectsByPrefix(ShortName);  
 TRO() ;
return(0);
  }
 
//+------------------------------------------------------------------+
int start()
{
 
n       = 10;
j       = 0 ;

lbl[j]  = ShortName+j;
lbl2[j] = "C4 SCALPER "  ;
DoShowHD(j, colorHD);


string symbol = Symbols;
      
digits = MarketInfo(symbol,MODE_DIGITS) ; 
point  = MarketInfo(symbol,MODE_POINT) ;       
      
if(digits == 5 || digits == 3) { digits  = digits - 1 ; point = point * 10 ; }  
 
DoWork( symbol, period  )  ;  
         
j       = j + 1 ;

lbl[j]  = ShortName+j;
lbl2[j] = " "   ;
DoShow(j, colorHD); 
  

j       = j + 1 ;
lbl[j]  = ShortName+j;
lbl2[j] = " P | C | D  " ;
DoShowHD(j, colorHD);

j       = j + 1 ;
lbl[j]  = ShortName+j;
lbl2[j] = tAlert ;
DoShowHD(j, theColorTR);


WindowRedraw() ;
    
return(0);
}



//+------------------------------------------------------------------+
  
void DoShowHD( int u, color dsColor )
{

ObjectCreate(lbl[u],23,0,Time[0],PRICE_CLOSE);
ObjectSet(lbl[u], OBJPROP_CORNER, myCorner );
ObjectSet(lbl[u],OBJPROP_XDISTANCE, x001 + myChartX);
ObjectSet(lbl[u],OBJPROP_YDISTANCE,n+myChartY);
ObjectSetText(lbl[u],lbl2[u],myFontSize,myFont,dsColor);


n = n+20;

return(0);

}  

//+------------------------------------------------------------------+
  
void DoShow( int u, color dsColor )
{

ObjectCreate(lbl[u],23,0,Time[0],PRICE_CLOSE);
ObjectSet(lbl[u], OBJPROP_CORNER, myCorner );
ObjectSet(lbl[u],OBJPROP_XDISTANCE, x002+myChartX);
ObjectSet(lbl[u],OBJPROP_YDISTANCE,n+myChartY);
ObjectSetText(lbl[u],lbl2[u],myFontSize,myFont,theColor);

if( u > 0)
{

   string Lname = lbl[u]+"ARROW" ;
   ObjectDelete(Lname);
   ObjectCreate(Lname, 23,0,Time[0],PRICE_CLOSE);
   ObjectSetText(Lname, theArrow, 12, "WingDings", theColor);
   ObjectSet(Lname, OBJPROP_CORNER, myCorner);
   ObjectSet(Lname, OBJPROP_XDISTANCE, x003+myChartX );
   ObjectSet(Lname, OBJPROP_YDISTANCE, n+myChartY);  

     Lname = lbl[u]+"ARROWcharge" ;
   ObjectDelete(Lname);
   ObjectCreate(Lname, 23,0,Time[0],PRICE_CLOSE);
   ObjectSetText(Lname, theArrowCharge, 12, "WingDings", theColorCharge);
   ObjectSet(Lname, OBJPROP_CORNER, myCorner);
   ObjectSet(Lname, OBJPROP_XDISTANCE, x004+myChartX );
   ObjectSet(Lname, OBJPROP_YDISTANCE, n+myChartY);  
   
     Lname = lbl[u]+"ARROWdet" ;
   ObjectDelete(Lname);
   ObjectCreate(Lname, 23,0,Time[0],PRICE_CLOSE);
   ObjectSetText(Lname, theArrowDet, 12, "WingDings", theColorDet);
   ObjectSet(Lname, OBJPROP_CORNER, myCorner);
   ObjectSet(Lname, OBJPROP_XDISTANCE, x005+myChartX );
   ObjectSet(Lname, OBJPROP_YDISTANCE, n+myChartY);     
   
   
/* 
      Lname = lbl[u]+"price" ;
   
  ObjectDelete(Lname);
   ObjectCreate(Lname, 23,0,Time[0],PRICE_CLOSE);
   ObjectSetText(Lname, tAlert , myFontSize,myFont, theColor );
   ObjectSet(Lname, OBJPROP_CORNER, myCorner);
   ObjectSet(Lname, OBJPROP_XDISTANCE, x004+ myChartX );
   ObjectSet(Lname, OBJPROP_YDISTANCE, n+myChartY);  
*/
 
}


n = n+20;

}   
 
//+------------------------------------------------------------------+
 

bool   IsMini()         { return(StringFind(Symbol(),"m")  > -1); }

bool   IsDoubleDotted() { return(StringFind(Symbol(),"..") > -1); }

bool   IsDotted()       { return(StringFind(Symbol(),".")  > -1); }
  
//+------------------------------------------------------------------+
string TimeFrameToString(int tf)
{
   string tfs;
   switch(tf) {
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
      case PERIOD_MN1: tfs="MN";
   }
   return(tfs);
}


//+------------------------------------------------------------------+
string StringUpperCase(string str)
{
   string   s = str;
   int      lenght = StringLen(str) - 1;
   int      char;
   
   while(lenght >= 0)
      {
         char = StringGetChar(s, lenght);
         
         //
         //
         //
         //
         //
         
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                  s = StringSetChar(s, lenght, char - 32);
         else 
              if(char > -33 && char < 0)
                  s = StringSetChar(s, lenght, char + 224);
         lenght--;
   }
   return(s);
}

//+------------------------------------------------------------------+ 

void setUpStrings(string& array[],int& length, string source)
{
   source = StringUpperCase(StringTrimLeft(StringTrimRight(source)));
   if (StringSubstr(source,StringLen(source)-1,1) != ";")
                    source = StringConcatenate(source,";");

   //
   //
   //
   //
   //
   
   int  s = 0;
   int  i = StringFind(source,";",s);
   string current;
      while (i > 0)
      {
         current = StringSubstr(source,s,i-s);
         ArrayResize(array,ArraySize(array)+1);
                     array[ArraySize(array)-1] = current;
                     s = i + 1;
                     i = StringFind(source,";",s);
      }
   length = ArraySize(array);
}
 
  
//+------------------------------------------------------------------+

void DoWork( string myPair, int myPeriod )  
{
 
string customname = "C4_Primer" ;
 
     TheBufferTrixM15 = iCustom(myPair,PERIOD_M15,customname,
         TRIX_Period,
         Mode_Average_1,Mode_Average_2,Mode_Average_3,
         Input_Price, iArrow,CountBars,Draw_Closes,                
         6, 0);  
     
     TheBuffer = iCustom(myPair,myPeriod,customname,
         TRIX_Period,
         Mode_Average_1,Mode_Average_2,Mode_Average_3,
         Input_Price, iArrow,CountBars,Draw_Closes,                
         6, 0); 
         
         
theArrow = ArrowBomb ;          
   while(true)
   {
      if (TheBuffer == 1  ) { theColor = colorBUY;   break ;}  
      if (TheBuffer == -1 ) { theColor = colorSHORT; break ;}     
                              theColor = colorWAIT;     

      break ;
   } // while                      
       
       
string customnameCharge = "C4_Charge" ;
     
     TheBufferCharge = iCustom(myPair,myPeriod,customnameCharge,
       MAPeriod,
       MAType,
      MAAppliedPrice,
         3, 0); 
         
theArrowCharge = ArrowBomb ;         
         
   while(true)
   {
      if (TheBufferCharge == 1  ) { theColorCharge = colorBUY;   break ;}  
      if (TheBufferCharge == -1 ) { theColorCharge = colorSHORT; break ;}     
                                    theColorCharge = colorWAIT;     
   
      break ;
   } // while                      
         
 
     
     TheBufferDet = iMomentum(myPair,myPeriod,4,PRICE_CLOSE,0)  ; 
         
theArrowDet = ArrowBomb ;         
         
   while(true)
   {
      if (TheBufferTrixM15 == 1  && TheBufferDet > 100 ) { tAlert     = "C4 BUY   "  ; theColorDet = colorBUY;   break ;}  
      if (TheBufferTrixM15 == -1 && TheBufferDet < 100 ) { tAlert     = "C4 SHORT "  ; theColorDet = colorSHORT; break ;}     
                                                          theColorDet = colorWAIT;     
   
      break ;
   } // while         iMomentum(NULL,0,12,PRICE_CLOSE,0)    
         
   
if(theColor == theColorCharge && theColorCharge == theColorDet )
{
   theColorTR = theColor ;
   
   if ( plunger && Trigger != Time[0] &&  Sound.Alert ) 
   {
      Trigger = Time[0] ;  
      PlaySound(Sound.File);
      plunger = false ;         
   }   
   
}   
else
{
   plunger    = true ;
   theColorTR = colorWAIT ;
   tAlert     = "C4 WAIT  " ;
}      
                           
} //    



//+------------------------------------------------------------------+  
void TRO()
{   
   
   string tObjName03    = "TROTAG"  ;  
   ObjectCreate(tObjName03, OBJ_LABEL, 0, 0, 0);//HiLow LABEL
   ObjectSetText(tObjName03, CharToStr(78) , 12 ,  "Wingdings",  DimGray );
   ObjectSet(tObjName03, OBJPROP_CORNER, 3);
   ObjectSet(tObjName03, OBJPROP_XDISTANCE, 5 );
   ObjectSet(tObjName03, OBJPROP_YDISTANCE, 5 );  
}
//+------------------------------------------------------------------+
/*
  
//+------------------------------------------------------------------+

string fFill(string filled, int f ) 
{
   string FILLED ;
   
   FILLED = StringSubstr(filled + "                                         ",0,f) ;
   
return(FILLED);
}
       
Comment(
"myPair " , myPair , "\n" ,   
"TheBuffer " , DoubleToStr(TheBuffer,Digits) , "\n" ,    
"TheBufferCharge " , DoubleToStr(TheBufferCharge,Digits) , "\n" ,   

"") ;  
  
void DoColor( double c1, double c2 )
{

if(c1 > c2 ) { pColor = colorUp ; pArrow = ArrowU; } else {
if(c1 < c2 ) { pColor = colorDn ; pArrow = ArrowD; } else { pColor = colorEq ; pArrow = ArrowR; } } 

} 
   
 
Comment(
"myPair " , myPair , "\n" ,   
"PipDiffHigh " , DoubleToStr(PipDiffHigh,Digits) , "\n" ,    
"PipDiffLow " , DoubleToStr(PipDiffLow,Digits) , "\n" ,   

"") ;  

Comment(
"arrNZD[0] " , DoubleToStr(arrNZD[0],Digits) , "\n" ,   
"arrNZD[1] " , DoubleToStr(arrNZD[1],Digits) , "\n" ,    
"arrNZD[Bars] " , DoubleToStr(arrNZD[Bars],Digits) , "\n" ,   

"") ; 

//+------------------------------------------------------------------+
string rtadjust( string rString )
{
 
 int sl = StringLen(rString) ;
 
 while(true)
 {
 
   if( sl == 5) { break ; } 
   if( sl == 4) { rString = " " + rString ; break ; }    
   if( sl == 3) { rString = "  " + rString ; break ; } 
   if( sl == 2) { rString = "   " + rString ; break ; } 
   if( sl == 1) { rString = "    " + rString ; break ; } 
    
   break ;
 }

return(rString) ;
}       

*/